
package de.ivu.elect.presentation.wahl.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlterminEdit;
import de.ivu.elect.business.wahl.entity.Wahltermin;
import de.ivu.elect.jee.faces.FacesContextUtil;

public class WahlterminEntsperrenAction extends AbstractWahlterminAction {

  private static final long serialVersionUID = 1L;


  @Inject
  private transient WahlterminEdit wahlterminEdit;

  @Override
  public UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLTERMIN_ENTSPERREN;
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Wahltermin entity) {
    return super.isDisabledInternal(entity) || !entity.getStatus().isGesperrt();
  }

  @Override
  public String doIt(Wahltermin wahltermin) {
    wahlterminEdit.wahlEntsperren(wahltermin);

    messages.addInfoMessage("wahltermin.edit.action.unlock.success.message", wahltermin.getName());

    return FacesContextUtil.getCurrentViewId();
  }

  @Override
  public boolean isFireChangeEvent() {
    return true;
  }

  @Override
  public String getLabelKey() {
    return "wahltermin.edit.action.unlock";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconUnlock();
  }
}
